Index: branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icb_oce.F90
===================================================================
--- branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icb_oce.F90	(revision 3339)
+++ branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icb_oce.F90	(revision 3359)
@@ -88,6 +88,6 @@
    INTEGER                         ::   current_year
    REAL(wp)                        ::   current_yearday            ! 1.00-365.99
-   REAL(wp), DIMENSION(:), POINTER ::   initial_width, initial_length
-   LOGICAL                         ::   restarted_bergs=.false.          ! Indicate whether we read state from a restart or not
+   REAL(wp), DIMENSION(:), POINTER ::   first_width, first_length
+   LOGICAL                         ::   l_restarted_bergs=.FALSE.          ! Indicate whether we read state from a restart or not
    !                                                           ! arbitrary numbers for diawri entry
    REAL(wp), DIMENSION(nclasses), PUBLIC ::   class_num=(/ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 /)
@@ -107,15 +107,15 @@
 
    !!gm almost all those PARAM ARE defined in NEMO
-   REAL(wp), PUBLIC, PARAMETER :: rho_ice      = 916.7_wp   ! Density of fresh ice @ 0oC (kg/m^3)
-   REAL(wp), PUBLIC, PARAMETER :: rho_water    = 999.8_wp   ! Density of fresh water @ 0oC (kg/m^3)
-   REAL(wp), PUBLIC, PARAMETER :: rho_air      = 1.1_wp     ! Density of air @ 0oC (kg/m^3) ???
-   REAL(wp), PUBLIC, PARAMETER :: rho_seawater = 1025._wp   ! Approx. density of surface sea water @ 0oC (kg/m^3)
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_ice      = 916.7_wp   ! Density of fresh ice @ 0oC (kg/m^3)
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_water    = 999.8_wp   ! Density of fresh water @ 0oC (kg/m^3)
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_air      = 1.1_wp     ! Density of air @ 0oC (kg/m^3) ???
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_seawater = 1025._wp   ! Approx. density of surface sea water @ 0oC (kg/m^3)
    !!gm end
-   REAL(wp), PUBLIC, PARAMETER :: Cd_av = 1.3_wp      ! (Vertical) Drag coefficient between bergs and atmos (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_ah = 0.0055_wp   ! (Horizontal) Drag coefficient between bergs and atmos (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_wv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and ocean (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_wh = 0.0012_wp   ! (Horizontal) Drag coefficient between bergs and ocean (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_iv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and sea-ice (?)
-   !TOM> no horizontal drag for sea ice! real, PARAMETER :: Cd_ih=0.0012 ! (Horizontal) Drag coefficient between bergs and sea-ice (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_av = 1.3_wp      ! (Vertical) Drag coefficient between bergs and atmos (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_ah = 0.0055_wp   ! (Horizontal) Drag coefficient between bergs and atmos (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_wv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and ocean (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_wh = 0.0012_wp   ! (Horizontal) Drag coefficient between bergs and ocean (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_iv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and sea-ice (?)
+   !TOM> no horizontal drag for sea ice! real, PARAMETER :: pp_Cd_ih=0.0012 ! (Horizontal) Drag coefficient between bergs and sea-ice (?)
 
    !                                           !** namberg namelist parameters (and defaults) **
@@ -147,14 +147,14 @@
 
    ! Single instance of an icebergs type initialised in icebergs_init and updated in icebergs_run
-   REAL(wp), ALLOCATABLE, PUBLIC, SAVE, DIMENSION(:,:)     ::   p_calving, p_calving_hflx
+   REAL(wp), ALLOCATABLE, PUBLIC, SAVE, DIMENSION(:,:)     ::   src_calving, src_calving_hflx
    INTEGER              , PUBLIC, SAVE                     ::   numicb 
-   INTEGER              , PUBLIC, SAVE, DIMENSION(nkounts) ::   kount_bergs
-   INTEGER              , PUBLIC, SAVE                     ::   icbdi, icbei, icbdj, icbej
-   REAL(wp)             , PUBLIC, SAVE                     ::   icb_left, icb_right
-   INTEGER              , PUBLIC, SAVE                     ::   icbpack
-   INTEGER              , PUBLIC, SAVE                     ::   ktberg, knberg
-   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   icbfldpts
-   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   icbflddest
-   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   icbfldproc
+   INTEGER              , PUBLIC, SAVE, DIMENSION(nkounts) ::   num_bergs
+   INTEGER              , PUBLIC, SAVE                     ::   nicbdi, nicbei, nicbdj, nicbej
+   REAL(wp)             , PUBLIC, SAVE                     ::   ricb_left, ricb_right
+   INTEGER              , PUBLIC, SAVE                     ::   nicbpack
+   INTEGER              , PUBLIC, SAVE                     ::   nktberg, nknberg
+   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   nicbfldpts
+   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   nicbflddest
+   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   nicbfldproc
 
    TYPE(FLD), ALLOCATABLE, PUBLIC     , DIMENSION(:)       ::   sf_icb       ! structure: file information, fields read