Index: /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Biblio/Biblio.bib
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Biblio/Biblio.bib	(revision 3367)
+++ /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Biblio/Biblio.bib	(revision 3368)
@@ -2064,4 +2064,17 @@
   volume = {3},
   pages = {1--20}
+}
+
+
+@article{Martin_Adcroft_OM10,
+author = {T. Martin and A. Adcroft},
+title = {Parameterizing the fresh-water flux from land ice to ocean with interactive icebergs in a coupled climate model},
+journal = OM,
+year = {2010},
+volume = {34}, number = {3--4},
+pages = {111--124},
+issn = {1463-5003},
+doi = {10.1016/j.ocemod.2010.05.001},
+url = {http://dx.doi.org/10.1016/j.ocemod.2010.05.001}
 }
 
Index: /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Chapters/Chap_SBC.tex
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 3367)
+++ /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 3368)
@@ -866,4 +866,67 @@
 %}
 
+
+% ================================================================
+%        Handling of icebergs
+% ================================================================
+\section{ Handling of icebergs (ICB) }
+\label{ICB_icebergs}
+%------------------------------------------namberg----------------------------------------------------
+\namdisplay{namberg}
+%-------------------------------------------------------------------------------------------------------------
+
+Icebergs are modelled as lagrangian particles in NEMO.
+Their physical behaviour is controlled by equations as described in  \citet{Martin_Adcroft_OM10} ).
+(Note that the authors kindly provided a copy of their code to act as a basis for implementation in NEMO.)
+Icebergs are initially spawned into one of ten classes which have specific mass and thickness as described by
+\np{rn\_initial\_mass} and \np{rn\_initial\_thickness}.
+Each class has an associated scaling (\np{rn\_mass\_scaling}), which is an integer representing how many icebergs 
+of this class are being described as one lagrangian point (this reduces the numerical problem of tracking every single iceberg).
+They are enabled by setting \np{ln\_icebergs}~=~true.
+
+Two initialisation schemes are possible.
+\begin{description}
+\item[\np{nn\_test\_icebergs}~$>$~0]
+In this scheme, the value of \np{nn\_test\_icebergs} represents the class of iceberg to generate 
+(so between 1 and 10), and \np{nn\_test\_icebergs} provides a lon/lat box in the domain at each 
+grid point of which an iceberg is generated at the beginning of the run. 
+(Note that this happens each time the timestep equals \np{nn\_nit000}.)
+\np{nn\_test\_icebergs} is defined by four numbers in \np{nn\_test\_box} representing the corners 
+of the geographical box: lonmin,lonmax,latmin,latmax
+\item[\np{nn\_test\_icebergs}~=~-1]
+In this scheme the model reads a calving file supplied in the \np{sn\_icb} parameter.
+This should be a file with a field on the configuration grid (typically ORCA) representing ice accumulation rate at each model point. 
+These should be ocean points adjacent to land where icebergs are known to calve.
+Most points in this input grid are going to have value zero.
+When the model runs, ice is accumulated at each grid point which has a non-zero source term.
+At each time step, a test is performed to see if there is enough ice mass to calve an iceberg of each class in order (1 to 10).
+Note that this is the initial mass multiplied by the number each particle represents ($i.e.$ the scaling).
+If there is enough ice, a new iceberg is spawned and the total available ice reduced accordingly.
+\end{description}
+
+Icebergs are influenced by wind, waves and currents, bottom melt and erosion.
+The latter act to disintegrate the iceberg. This is either all melted freshwater, or 
+(if \np{rn\_bits\_erosion\_fraction}~$>$~0) into melt and additionally small ice bits
+which are assumed to propagate with their larger parent and thus delay fluxing into the ocean.
+Melt water (and other variables on the configuration grid) are written into the main NEMO model output files.
+
+Extensive diagnostics can be produced.
+Separate output files are maintained for human-readable iceberg information.
+A separate file is produced for each processor (independent of \np{ln\_ctl}).
+The amount of information is controlled by two integer parameters:
+\begin{description}
+\item[\np{nn\_verbose\_level}]  takes a value between one and four and represents 
+an increasing number of points in the code at which variables are written, and an 
+increasing level of obscurity.
+\item[\np{nn\_verbose\_write}] is the number of timesteps between writes
+\end{description}
+
+Iceberg trajectories can also be written out and this is enabled by setting \np{nn\_sample\_rate}~$>$~0.
+A non-zero value represents how many timesteps between writes of information into the output file.
+These output files are in NETCDF format.
+When \key{mpp\_mpi} is defined, each output file contains only those icebergs in the corresponding processor,
+so care is needed to recreate data for individual icebergs.
+
+
 % ================================================================
 % Miscellanea options
@@ -1047,63 +1110,4 @@
 
 % -------------------------------------------------------------------------------------------------------------
-%        Handling of icebergs
-% -------------------------------------------------------------------------------------------------------------
-\subsection{ Handling of icebergs (ICB) }
-\label{ICB_icebergs}
-%------------------------------------------namberg----------------------------------------------------
-\namdisplay{namberg}
-%-------------------------------------------------------------------------------------------------------------
-
-Icebergs are modelled as lagrangian particles in NEMO.
-Their physical behaviour is controlled by equations as described in Martin and Adcroft (2010).
-(Note that the authors kindly provided a copy of their code to act as a basis for implementation in NEMO.)
-Icebergs are initially spawned into one of ten classes which have specific mass and thickness as described by
-\np{rn\_initial\_mass} and \np{rn\_initial\_thickness}.
-Each class has an associated scaling (\np{rn\_mass\_scaling}), which is an integer representing how many icebergs 
-of this class are being described as one lagrangian point (this reduces the numerical problem of tracking every single iceberg).
-They are enabled by setting \np{ln\_icebergs}~=~true.
-
-Two initialisation schemes are possible.
-\begin{description}
-\item[\np{nn\_test\_icebergs}~>~0]
-In this scheme, the value of \np{nn\_test\_icebergs} represents the class of iceberg to generate (so between 1 and 10), and 
-\np{nn\_test\_icebergs} provides a lon/lat box in the domain at each grid point of which an iceberg is generated at the 
-beginning of the run. (Note that this happens each time the timestep equals \np{nn\_nit000}.)
-\np{nn\_test\_icebergs} is defined by four numbers in \np{nn\_test\_box} representing the corners of the geographical
-box: lonmin,lonmax,latmin,latmax
-\item[\np{nn\_test\_icebergs}~=~-1]
-In this scheme the model reads a calving file supplied in the \np{sn\_icb} parameter.
-This should be a file with a field on the configuration grid (typically ORCA) representing ice accumulation rate at each model point. 
-These should be ocean points adjacent to land where icebergs are known to calve.
-Most points in this input grid are going to have value zero.
-When the model runs, ice is accumulated at each grid point which has a non-zero source term.
-At each time step, a test is performed to see if there is enough ice mass to calve an iceberg of each class in order (1 to 10).
-Note that this is the initial mass multiplied by the number each particle represents (i.e. the scaling).
-If there is enough ice, a new iceberg is spawned and the total available ice reduced accordingly.
-\end{description}
-
-Icebergs are influenced by wind, waves and currents, bottom melt and erosion.
-The latter act to disintegrate the iceberg.
-This is either all melted freshwater, or (if \np{rn\_bits\_erosion\_fraction}~>~0) into melt and additionally small ice bits
-which are assumed to propagate with their larger parent and thus delay fluxing into the ocean.
-Melt water (and other variables on the configuration grid) are written into the main NEMO model output files.
-
-Extensive diagnostics can be produced.
-Separate output files are maintained for human-readable iceberg information.
-A separate file is produced for each processor (independent of \np{ln\_ctl}).
-The amount of information is controlled by two integer parameters:
-\begin{description}
-\item[\np{nn\_verbose\_level}]  takes a value between one and four and represents an increasing number of points in the code
-at which variables are written, and an increasing level of obscurity.
-\item[\np{nn\_verbose\_level}] is the number of timesteps between writes
-\end{description}
-
-Iceberg trajectories can also be written out and this is enabled by setting \np{nn\_sample\_rate}~>~0.
-A non-zero value represents how many timesteps between writes of information into the output file.
-These output files are in NETCDF format.
-When \key{mpp\_mpi} is defined, each output file contains only those icebergs in the corresponding processor,
-so care is needed to recreate data for individual icebergs.
-
-% -------------------------------------------------------------------------------------------------------------
 %        Freshwater budget control 
 % -------------------------------------------------------------------------------------------------------------