Index: /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Chapters/Chap_SBC.tex
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 3368)
+++ /branches/2012/dev_r3337_NOCS10_ICB/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 3369)
@@ -925,6 +925,8 @@
 A non-zero value represents how many timesteps between writes of information into the output file.
 These output files are in NETCDF format.
-When \key{mpp\_mpi} is defined, each output file contains only those icebergs in the corresponding processor,
-so care is needed to recreate data for individual icebergs.
+When \key{mpp\_mpi} is defined, each output file contains only those icebergs in the corresponding processor.
+Trajectory points are written out in the order of their parent iceberg in the model's "linked list" of icebergs.
+So care is needed to recreate data for individual icebergs, since its trajectory data may be spread across
+multiple files.
 
 
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3368)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3369)
@@ -324,9 +324,12 @@
       nn_verbose_write         = 15                   ! Timesteps between verbose messages
       nn_sample_rate           = 1                    ! Timesteps between sampling for trajectory storage
+                                                      ! Initial mass required for an iceberg of each class
       rn_initial_mass          = 8.8e7, 4.1e8, 3.3e9, 1.8e10, 3.8e10, 7.5e10, 1.2e11, 2.2e11, 3.9e11, 7.4e11
+                                                      ! Proportion of calving mass to apportion to each class  
       rn_distribution          = 0.24, 0.12, 0.15, 0.18, 0.12, 0.07, 0.03, 0.03, 0.03, 0.02
                                                       ! Ratio between effective and real iceberg mass (non-dim)
+                                                      ! i.e. number of icebergs represented at a point         
       rn_mass_scaling          = 2000, 200, 50, 20, 10, 5, 2, 1, 1, 1
-                                                      ! Total thickness of newly calved bergs (m)
+                                                      ! thickness of newly calved bergs (m)
       rn_initial_thickness     = 40., 67., 133., 175., 250., 250., 250., 250., 250., 250.
       rn_rho_bergs             = 850.                 ! Density of icebergs
@@ -336,5 +339,6 @@
       rn_sicn_shift            = 0.                   ! Shift of sea-ice concn in erosion flux (0<sicn_shift<1)
       ln_passive_mode          = .false.              ! iceberg - ocean decoupling   
-      nn_test_icebergs         =  10                  ! Create icebergs in absence of a calving file (-1 = no)
+      nn_test_icebergs         =  10                  ! Create test icebergs of this class (-1 = no)
+                                                      ! Put a test iceberg at each gridpoint in box (lon1,lon2,lat1,lat2)
       rn_test_box              = 108.0,  116.0, -66.0, -58.0
       rn_speed_limit           = 0.                   ! CFL speed limit for a berg   
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbini.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbini.F90	(revision 3368)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbini.F90	(revision 3369)
@@ -193,5 +193,6 @@
          i2 = INT( i3/nicbpack )
          i1 = i3 - i2*nicbpack
-         IF( i1 == nimpp+ji-1 ) THEN
+         i3 = INT( src_calving_hflx(ji,jj) )
+         IF( i1 == nimpp+ji-1 .AND. i3 == narea ) THEN
             IF( nicbdi < 0 ) THEN
                nicbdi = ji
@@ -210,5 +211,6 @@
          i2 = INT( i3/nicbpack )
          i1 = i3 - i2*nicbpack
-         IF( i2 == njmpp+jj-1 ) THEN
+         i3 = INT( src_calving_hflx(ji,jj) )
+         IF( i2 == njmpp+jj-1 .AND. i3 == narea ) THEN
             IF( nicbdj < 0 ) THEN
                nicbdj = jj